#Import the library 
import pygame 

#Classes 
class Character(): 
    def __init__(self,name,age,x_start,y_start, image): 
        self.name = name 
        self.age = age  
        self.x_speed = 0
        self.y_speed = 0 
        self.image = pygame.image.load(image)
        self.rect = self.image.get_rect()
        self.rect.x = x_start
        self.rect.y = y_start
        self.imageWidth = self.image.get_width() 
        self.imageHeight = self.image.get_height() 

    def draw(self, screen, rect): 
        screen.blit(self.image, rect)

class Object(): 
    def __init__(self,name,x_start,y_start, image): 
        self.name = name 
        self.image = pygame.image.load(image)
        self.rect = self.image.get_rect()
        self.rect.x = x_start
        self.rect.y = y_start
        self.imageWidth = self.image.get_width() 
        self.imageHeight = self.image.get_height() 

    def draw(self, screen, rect): 
        screen.blit(self.image, rect)


#Initialise the engine 
pygame.init() 

#Opening a window 

size = (800,600) 
screen = pygame.display.set_mode(size)
Background = pygame.image.load("Background.png") 

#Set window title 
pygame.display.set_caption("Adventure Game") 

#loop unti the user clicks the close button 
done = False 
people = [] 
people.append(Character("bob",0,10,260,"HeroSmall.png")) 

objects = []
objects.append(Object("house",560,300,"House.png")) 


#Used to manage how fast the screen updates 
clock = pygame.time.Clock() 

# ------ Main program Loop ------ 

while not done: 
    # --- Main event loop 
    for event in pygame.event.get(): #User did something 

        if event.type == pygame.QUIT: #If user clicked close 
            done = True #Flag that we are done and exit the loop 

        if event.type == pygame.KEYDOWN: 
            if event.key == pygame.K_LEFT: 
                for i in people: 
                    i.x_speed = - 3 
            if event.key == pygame.K_RIGHT: 
                for i in people: 
                    i.x_speed = 3 
            if event.key == pygame.K_UP: 
                for i in people: 
                    i.y_speed = -3 
            if event.key == pygame.K_DOWN: 
                for i in people: 
                    i.y_speed = 3 
        if event.type == pygame.KEYUP: 
            if event.key == pygame.K_LEFT: 
                for i in people: 
                    i.x_speed = 0 
            if event.key == pygame.K_RIGHT: 
                for i in people: 
                    i.x_speed = 0 
            if event.key == pygame.K_UP: 
                for i in people: 
                    i.y_speed = 0 
            if event.key == pygame.K_DOWN: 
                for i in people: 
                    i.y_speed = 0 

    # ------ Game logic should go here ------ 
    for i in people:
        
        i.rect.x += i.x_speed 
        if i.rect.x < 1: 
            i.rect.x = 1 
        elif i.rect.x > size[0]-i.imageWidth: 
            i.rect.x = size[0]-i.imageWidth

        for object in objects:
          if i.rect.colliderect(object.rect):
            i.rect.x -= i.x_speed 
            break

        i.rect.y += i.y_speed 
        if i.rect.y < 1: 
            i.rect.y = 1 
        elif i.rect.y > size[1]-i.imageHeight: 
            i.rect.y = size[1]-i.imageHeight 

        for object in objects:
          if i.rect.colliderect(object.rect):
            i.rect.y -= i.y_speed 
            break
 
    # ------ Drawing code should go here ------- 

    # First, clear the screen to white. Don't put other drawing commands above this or they will be erased with this command. 

    screen.fill((255,255,255))
    screen.blit(Background, (0,0)) 
    for item in objects:
      item.draw(screen,item.rect)
    for character in people: 
      character.draw(screen,character.rect) 

    # Update the screen 
    pygame.display.update() 

    # ------ Limit to 60 frames per second ------ 

    clock.tick(60) 

pygame.quit() 

 

 